----------------------------------------------------------------------
-- Voltage-controlled Current Source (vccs) : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.ELECTRICAL_SYSTEMS.all;

entity vccs is
  generic ( gain : REAL);
  port(terminal EL_in_p,
                    EL_in_m,
                    EL_out_p,
                    EL_out_m : ELECTRICAL);
end entity vccs;

architecture behav of vccs is
  quantity V_out_el across I_out_el through EL_out_p to EL_out_m;
  quantity V_in_el across EL_in_p to EL_in_m;
begin
  I_out_el == gain * V_in_el;
end architecture behav;
