----------------------------------------------------------------------
-- Current-controlled Current Source (cccs) : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.ELECTRICAL_SYSTEMS.all;

entity cccs is
  generic ( gain : REAL :=50.0);
  port(terminal EL_in_p,
                    EL_in_m,
                    EL_out_p,
                    EL_out_m : ELECTRICAL);
end entity cccs;

architecture behav of cccs is
  quantity V_out_el across I_out_el through EL_out_p to EL_out_m;
  quantity V_in_el across I_in_el through EL_in_p  to EL_in_m;
begin
  if domain = quiescent_domain use
    V_in_el  == 0.0;
    V_out_el == 0.0;
    I_in_el  == 0.0;
  else
    I_out_el == gain * I_in_el;
    V_in_el  == 0.0;
  end use;
end architecture behav;
