----------------------------------------------------------------------
-- Transformer : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.ELECTRICAL_SYSTEMS.all;
use IEEE.MATH.REAL.all;

entity trnsfrm is
  generic(L1 : REAL := 1.0e-1;
            L2 : REAL := 4.0e-1;
            K  : REAL := 1.0 );
  port(terminal  EL_1_p  : ELECTRICAL;
        terminal  EL_1_m  : ELECTRICAL;
        terminal  EL_2_p  : ELECTRICAL;
        terminal  EL_2_m  : ELECTRICAL );
end entity trnsfrm;

architecture behav of trnsfrm is
  constant M : REAL := K*SQRT(L1*L2);
  quantity V_el_1 across I_el_1 through EL_1_p to EL_1_m;
  quantity V_el_2 across I_el_2 through EL_2_p to EL_2_m;
begin
  V_el_1 == L1 * I_el_1'DOT + M * I_el_2'DOT;
  V_el_2 == M * I_el_1'DOT + L2 * I_el_2'DOT;
end architecture behav;
