----------------------------------------------------------------------
-- Full Adder : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity full_adder is
  port(DIN1: in STD_LOGIC;
       DIN2: in STD_LOGIC;
       CARRYIN: in STD_LOGIC;
       SUM: out STD_LOGIC;
       CARRYOUT: out STD_LOGIC);
end entity full_adder;

architecture behav of full_adder is
  signal n1,n2,n3,n4: STD_LOGIC;
  signal sum1,carry1,carry2: STD_LOGIC;
begin
  n1 <= DIN1 or DIN2;
  n2 <= DIN1 nand DIN2;
  carry1 <= not n2;
  sum1 <= n1 and n2;
  n3 <= sum1 or CARRYIN;
  n4 <= sum1 nand CARRYIN;
  carry2 <= not n4;
  SUM <= n3 and n4;
  CARRYOUT <= carry1 or carry2;
end architecture behav;