----------------------------------------------------------------------
-- 4 bit Adder : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity ADDER_4BITS is
  port(D1,D2: in STD_LOGIC_VECTOR(3 downto 0);
       CARRY_IN: in STD_LOGIC;
       SUM_4BITS: out STD_LOGIC_VECTOR(3 downto 0);
       CARRY_OUT: out STD_LOGIC);
end entity ADDER_4BITS;

architecture behav of ADDER_4BITS is
  component full_adder
    port(DIN1,DIN2: in STD_LOGIC;
         CARRYIN: in STD_LOGIC;
         SUM,CARRYOUT: out STD_LOGIC);
  end component full_adder;
  signal COUT: STD_LOGIC_VECTOR(3 downto 0) := "0000";
begin
  U0: full_adder port map(D1(0), D2(0), CARRY_IN,SUM_4BITS(0), COUT(0));
  U1: full_adder port map(D1(1), D2(1), COUT(0), SUM_4BITS(1), COUT(1));
  U2: full_adder port map(D1(2), D2(2), COUT(1), SUM_4BITS(2), COUT(2));
  U3: full_adder port map(D1(3), D2(3), COUT(2), SUM_4BITS(3), COUT(3));
  CARRY_OUT <= COUT(3);
end architecture behav;