-------------------------------------------------------------------------------
-- LCR coil 
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
library IEEE ; 
    use IEEE.ELECTRICAL_SYSTEMS.all ;
--------------------
entity COIL_LCR is
  generic (
    R : RESISTANCE := 80.0 ;    --[80Ohm]
    L : INDUCTANCE := 10.0e-3 ; --[10mH]
    C : CAPACITANCE := 4.0e-12  --[4pF]
  ) ; 
  port (
    terminal EL1, EL2 : ELECTRICAL 
  ) ;
end entity COIL_LCR ; 
--------------------
architecture ARCH_2Q of COIL_LCR is 

    quantity Vrl across Irl through EL1 to EL2 ;
    quantity Vc across Ic through EL1 to EL2 ; 

begin 

    Vrl == Irl * R + L*Irl'dot ; 
    Vc * C == Ic'integ ; 

end architecture ARCH_2Q ; 
