-------------------------------------------------------------------------------
-- LCR coil (voltage equation separated) 
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
library IEEE ; 
    use IEEE.ELECTRICAL_SYSTEMS.all ;
--------------------
entity COIL_LCR is
  generic (
    R : RESISTANCE := 80.0 ;    --[80Ohm]
    L : INDUCTANCE := 10.0e-3 ; --[10mH]
    C : CAPACITANCE := 4.0e-12  --[4pF]
  ) ; 
  port (
    terminal EL1, EL2 : ELECTRICAL 
  ) ;
end entity COIL_LCR ;
--------------------
architecture ARCH of COIL_LCR is 

    terminal T1 : ELECTRICAL ;
    quantity Vr across Ir through EL1 to T1 ;
    quantity Vl across Il through T1 to EL2 ; 
    quantity Vc across Ic through EL1 to EL2 ; 

begin 

    Vr == Ir * R ; 
    Vl == L * Il'dot ; 
    Vc * C == Ic'integ ; 

end architecture ARCH ; 

