-------------------------------------------------------------------------------
-- LCR coil (structure model style) 
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
library IEEE ; 
    use IEEE.ELECTRICAL_SYSTEMS.all ;
--------------------
entity COIL_LCR is
  generic (
    R : RESISTANCE := 80.0 ;    --[80Ohm]
    L : INDUCTANCE := 10.0e-3 ; --[10mH]
    C : CAPACITANCE := 4.0e-12  --[4pF]
  ) ; 
  port (
    terminal EL1, EL2 : ELECTRICAL 
  ) ;
end entity COIL_LCR ;
--------------------
architecture ARCH_STRUCT of COIL_LCR is 

    TERMINAL T1 : ELECTRICAL ; 

begin 
	
    RES1: entity work.res(IDEAL)
        generic map(R=>R)
        port map(P=>EL1, M=>T1) ; 

    IND1: entity work.ind(IDEAL)
        generic map(L=>L)
        port map(P=>T1, M=>EL2) ; 

    CAP1: entity work.cap(IDEAL)
        generic map(C=>C)
        port map(P=>EL1, M=>EL2) ; 

end architecture ARCH_STRUCT ; 

