----------------------------------------------------------------------
-- Sinusoidal Source with Limit Statement : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.ELECTRICAL_SYSTEMS.all;
use IEEE.MATH_REAL.all;

entity vsin2 is
  generic(freq: REAL := 1.0e+6; -- frequency [Hz]
  amp: REAL := 1.0; -- amplitude [V]
  voff: REAL := 0.0); -- offset voltage [V]
  port(terminal EL_p,EL_m : ELECTRICAL);
end entity vsin2;

architecture behav of vsin2 is
  quantity V_el_src across I_el_src through EL_p to EL_m;
  limit V_el_src: voltage with 1.0/freq/20.0;
begin
  V_el_src == voff+amp*sin(math_2_pi*freq* NOW);
end architecture behav;
