----------------------------------------------------------------------
-- Analog Power Amplifier : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.ELECTRICAL_SYSTEMS.all;
use IEEE.MATH_REAL.all;

entity analog_amp is
end analog_amp;

architecture struct of analog_amp is

  -- Internal buses of this cell.

  -- Internal signals of this cell.
  terminal drive_curr_in : ELECTRICAL ;
  terminal dc_v_source : ELECTRICAL ;
  terminal ctrl_curr_in : ELECTRICAL ;
  terminal drive_curr_out_2 : ELECTRICAL ;
  terminal volt_in : ELECTRICAL ;
  terminal inject_pnt : ELECTRICAL ;


begin
  r_load_2 : entity WORK.res(behav) 
    generic map (
      r => 1.0)
    port map (
      el_p => drive_curr_out_2,
      el_m => ground);

  vdc3 : entity WORK.vdc(behav) 
    generic map (
      amp => 30.0)
    port map (
      el_p => dc_v_source,
      el_m => ground);

  isol_trans : entity WORK.trnsfrm(behav) 
    generic map (
      l2 => 40.0,
      l1 => 10.0)
    port map (
      el_1_p => dc_v_source,
      el_1_m => drive_curr_in,
      el_2_p => drive_curr_out_2,
      el_2_m => ground);

  cccs3 : entity WORK.cccs(behav) 
    generic map (
      gain => 10000.0)
    port map (
      el_in_m => ground,
      el_out_p => drive_curr_in,
      el_out_m => ground,
      el_in_p => ctrl_curr_in);

  r_ctrl_curr : entity WORK.res(behav) 
    generic map (
      r => 500.0)
    port map (
      el_p => inject_pnt,
      el_m => ctrl_curr_in);

  r_bias_2 : entity WORK.res(behav) 
    generic map (
      r => 2200.0)
    port map (
      el_p => inject_pnt,
      el_m => ground);

  r_bias_1 : entity WORK.res(behav) 
    generic map (
      r => 10000.0)
    port map (
      el_p => dc_v_source,
      el_m => inject_pnt);

  c_dc_cut : entity WORK.cap(behav) 
    generic map (
      c => 2.000000e-004)
    port map (
      el_p => volt_in,
      el_m => inject_pnt);

  vsin2_1 : entity WORK.vsin2(behav) 
    generic map (
      freq => 100.0,
      amp => 5.0)
    port map (
      el_p => volt_in,
      el_m => ground);

end struct;
