----------------------------------------------------------------------
-- DA Converter : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.ELECTRICAL_SYSTEMS.all;
use IEEE.STD_LOGIC_1164.all;

entity dac1bit is
  generic(VH: REAL := 5.0;
          VL: REAL := 0.0;
          tr: REAL := 1.0e-8;
          tf: REAL := 1.0e-8);
  port(digin: in STD_LOGIC;
       terminal VREF: ELECTRICAL;
       terminal VOUT: ELECTRICAL);
end entity dac1bit;

architecture behav of dac1bit is
  quantity v across i through VOUT to VREF;
  signal sig: REAL := 0.0;
begin
  sig <= VH when digin = '1' else VL;
  v == sig'RAMP(tr,tf);
end architecture behav;