-------------------------------------------------------------------------------
-- Mechanical model
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
library IEEE ; 
    use IEEE.MECHANICAL_SYSTEMS.all ;
--------------------
entity SPRING_DAMPER_MASS_S is

  generic (
    D : in DAMPING := 0.02 ; -- damping [N s/m]
    K : in STIFFNESS := 0.1 ; -- stifness [N/m]
    M : in MASS := 0.1        -- mass [kg]
  ) ; 
  port(
    terminal MT1, MT2 : TRANSLATIONAL
  ) ; 
end entity SPRING_DAMPER_MASS_S;
--------------------
architecture ARCH of SPRING_DAMPER_MASS_S is

  quantity Sd across Fd through MT1 to MT2 ;
  quantity Sk across Fk through MT1 to MT2 ; 
  quantity Sm across Fm through MT2 to TRANSLATIONAL_REF ; 

begin
  Fd == D * Sd'dot ;  -- damper
  Fk == K * Sk ;     -- spring 
  Fm == M * Sm'dot'dot ; -- mass

end architecture ARCH ;
