-------------------------------------------------------------------------------
-- double port mass 
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
library IEEE ; 
    use IEEE.MECHANICAL_SYSTEMS.all ; 
--------------------
entity MASS_S2N is

  generic (
    M : in MASS := 0.1        -- mass [kg]
  ) ; 
  port(
    terminal MT1, MT2 : translational 
  ) ; 
end entity MASS_S2N;
--------------------
architecture ARCH of MASS_S2N is

  quantity St across Ft through MT1 to MT2 ;
  quantity S  across F  through MT1 to TRANSLATIONAL_REF ;

begin
  
  St == 0.0 ; 
  F == M * S'dot'dot ; -- mass

end architecture ARCH ;
