-------------------------------------------------------------------------------
-- PI control example
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
entity pi_control is
  generic(
    K  : REAL := 1.0 ; -- Propotional Gain
    Ti : REAL := 1.0   -- reset time
  ) ; 
  port(
    quantity X  : in REAL ; 
    quantity Y : out REAL 
  ) ; 
end entity pi_control;
---------------------
architecture behav of pi_control is
begin

	Y == K*X + K/Ti*X'integ ; 

end architecture behav;
---------------------
architecture behav_gs of pi_control is
  constant NUM : REAL_VECTOR := (1.0, Ti) ; 
  constant DEN : REAL_VECTOR := (0.0, Ti) ;
BEGIN

	Y == K*X'LTF(NUM, DEN) ;

end architecture behav_gs;
---------------------
architecture struct of pi_control is
  quantity Q_outK : REAL := 0.0;
  quantity Q_outI : REAL := 0.0;
begin

  Q_PROPORTIONAL_VDA1 : entity fundamentals_vda.Q_PROPORTIONAL_VDA(BASIC)
                        generic map ( K => K )
                        port map ( Q_IN => X, Q_OUT=>Q_outK );

  Q_INTEGRAL_VDA1 : entity fundamentals_vda.Q_INTEGRAL_VDA(BASIC)
                    generic map ( K => K/TI )
                    port map ( Q_IN => X, Q_OUT=>Q_outI);

  Q_ADD_VDA1 : entity fundamentals_vda.Q_ADD_VDA(BASIC)
               port map (Q_IN1 => Q_outK, Q_IN2 => Q_outI, Q_OUT=> Y );

end architecture struct;
