-------------------------------------------------------------------------------
-- analog comparator
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
entity COMP_JSAE is
   port (quantity QIN : in REAL := 0.0;
         quantity VLO : in REAL := -1.0;
         quantity VHI : in REAL := 1.0;
         quantity THRES : in REAL := 0.0;
         quantity QOUT : out REAL
   );
end entity COMP_JSAE;

architecture BEHAV of COMP_JSAE is
  signal crossing : BOOLEAN := FALSE;
begin
    crossing <= not QIN'ABOVE(THRES);
    break on crossing;

    if (crossing and (QIN < THRES)) use
        QOUT == VLO ;
    else
        QOUT == VHI ;
    end use;

end architecture BEHAV; 
