-------------------------------------------------------------------------------
-- analogy hysteresys comparator
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
entity HYCOMP_JSAE is
    generic (Y0 : REAL := 0.0	) ;
    port (quantity QIN : in REAL := 0.0;
          quantity VLO : in REAL := 1.0;
          quantity VHI : in REAL := -1.0;
          quantity THLO : in REAL := 0.0;
          quantity THHI : in REAL := 0.0;
          quantity QOUT : out REAL
    );
end entity HYCOMP_JSAE;

architecture BEHAV of HYCOMP_JSAE is
  signal sig : REAL := Y0 ;
  signal upper_crossing : BOOLEAN := FALSE;
  signal lower_crossing : BOOLEAN := TRUE;
begin
    upper_crossing <= QIN'ABOVE(THHI); --Interruption event : upper threshold
    lower_crossing <= not QIN'ABOVE(THLO); -- Interruption event : lower threshold
    break on upper_crossing, lower_crossing;  
    
    process (upper_crossing,lower_crossing) -- digital process
    begin
        if (QIN<THLO) then
            sig <= VLO;
        elsif (QIN > THHI) then
            sig <= VHI;
        elsif ((QIN > THLO) and (sig = VLO)) then
            sig <= VLO;
        elsif ((QIN < THHI) and (sig = VHI)) then
            sig <= VHI;
        end if ;
    end process ;

    QOUT == sig'RAMP(0.0); 
end architecture ;

