-------------------------------------------------------------------------------
-- analog AND block
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
entity QAND_JSAE is
  generic (
	TD : in REAL := 0.0 
  ) ; 
  port(
	quantity X1 : in REAL := 0.0 ; 
	quantity X2 : in REAL := 0.0 ;
	quantity Y : out REAL := 0.0 
  ) ;
end entity QAND_JSAE;
architecture arch_qand_jsae of QAND_JSAE is
    constant TDs : TIME := TD * 1 sec ;
    signal sw1, sw2 : BOOLEAN := FALSE ; 
    signal SOUT : REAL := 0.0 ;
begin

    sw1 <= X1'ABOVE(0.5) ;
    sw2 <= X2'ABOVE(0.5) ; 
    process (sw1, sw2) 
    begin 
      if(X1 > 0.5 and X2 >0.5) then 
        SOUT <= 1.0 after TDs ; 
      else 
        SOUT <= 0.0 after TDs ;
      end if ; 
    end process ;

    Y == SOUT'RAMP(0.0) ; 

end architecture arch_qand_jsae;
