-------------------------------------------------------------------------------
-- analog NOT block
--
-- Copyright (C) 2017 JSAE
------------------------------------------------------------------------------
entity QNOT_JSAE is
  generic (
    TD : in REAL := 0.0 
  ) ; 
  port(
    quantity X : in REAL := 0.0 ; 
    quantity Y : out REAL := 0.0 
  ) ; 
end entity QNOT_JSAE;
architecture arch_qnot of QNOT_JSAE is 
    constant TDs : TIME := TD * 1 sec ;
    signal sw : BOOLEAN := FALSE ;
    signal INV_OUT : REAL := 0.0 ;
begin

    sw <= X'ABOVE(0.5) ;
    process (sw) 
    begin 
      if(X > 0.5) then 
        INV_OUT <= 0.0 after TDs ; 
      else 
        INV_OUT <= 1.0 after TDs ;
      end if ; 
    end process ;

    Y == INV_OUT'RAMP(0.0) ; 

END ARCHITECTURE arch_qnot;
