-------------------------------------------------------------------------------
-- gearbox example (omunicaster style)
--
-- Copyright (C) 2017 JSAE
-------------------------------------------------------------------------------
library IEEE, FUNDAMENTALS_VDA ;
    use IEEE.MECHANICAL_SYSTEMS.all;
--------------------
entity GEARBOX is
  port    (
    quantity Q_GEAR :in REAL ;
    terminal MRV_IN  : ROTATIONAL_VELOCITY;
    terminal MRV_OUT : ROTATIONAL_VELOCITY 
  );
end entity GEARBOX ; 
--------------------
architecture arch_gearbox of GEARBOX is 
  quantity omg_in  across trq_in  through MRV_IN;
  quantity omg_out across trq_out through MRV_OUT;

  constant RATIO : REAL_VECTOR :=
          (0.0, 3.250, 1.782, 1.172, 0.909, 0.702);
  quantity R : REAL ;

begin

  R == RATIO(INTEGER(Q_GEAR));

  omg_in  == R * omg_out ;
  (-trq_out) == R * trq_in ; 
 
end architecture arch_gearbox;
