  ----------------------------------------------------------------------
-- Lowpass Filter in Frequencydomain: 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
  use IEEE.ELECTRICAL_SYSTEMS.all;
  use IEEE.MATH_REAL.all;
----------------------------------------------------------------------
entity lowpass is
  porti
    terminal EL_input: ELECTRICALG
    terminal EL_output: ELECTRICAL
  );
end entity lowpass;
----------------------------------------------------------------------
architecture LTF of lowpass is
  quantity vin across EL_input to electrical_ref;
  quantity vout across iout through EL_output to electrical_ref;
  constant wp : REAL := 10.0 * math_2_pi; -- pole in rad/s
  constant num : REAL_VECTOR := (wp, 0.0); -- Numerator array
  constant den : REAL_VECTOR := (wp, 1.0); -- Denominator array
begin

  vout == vin'LTF(num,den);

end architecture LTF;