----------------------------------------------------------------------
-- Stopper in Translational: 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
  use IEEE.MATH_REAL.all;
  use IEEE.MECHANICAL_SYSTEMS.all;
----------------------------------------------------------------------
entity stop_t_jsae is
  generic (
    k_stop : REAL;-- Stiffness of stop [No Units]
    pos_max : DISPLACEMENT;-- Maximum position [m]
    pos_min : DISPLACEMENT := 0.0;-- Minimum position [m]
    damp_stop : REAL := 1.0e-9-- Damping factor of stop [No Units]
  );
  port ( terminal MT_trans1,MT_ trans2 : TRANSLATIONAL);
end entity stop_t_jsae;
----------------------------------------------------------------------
architecture ideal of stop_t_jsae is
  quantity velocity : VELOCITY;
  quantity position across force through MT_trans1 to MT_trans2;

begin
  velocity == position'DOT;
  if position'ABOVE(pos_max) use
    force == k_stop * (position - pos_max) + (damp_stop * velocity);
  elsif position'ABOVE(pos_min) use
    force == 0.0;
  else
    force == k_stop * (position - pos_min) + (damp_stop * velocity);
  end use;

  break on position'ABOVE(pos_min),
  position'ABOVE(pos_max);
end architecture ideal;