----------------------------------------------------------------------
-- Stopper in Rotational : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
  use IEEE.MATH_REAL.all;
  use IEEE.MECHANICAL_SYSTEMS.all;
----------------------------------------------------------------------
entity stop_r_jsae is
  generic (
    k_stop : STIFFNESS; -- Stiffness of hard stop [N/m]
    damp_stop : DAMPING := 1.0e-9; -- Damping of hard stop [N*s/m]
    ang_max : ANGLE; -- Max angle [Radian]
    ang_min : ANGLE := 0.0 -- Min angle [Radian]
  );
  port ( terminal MR_ang1, MR_ang2 : rotational);
end entity stop_r_jsae;
----------------------------------------------------------------------
architecture ideal of stop_r_jsae is
  quantity velocity : VELOCITY;
  quantity ang across trq through MR_ang1 to MR_ang2;

begin
  velocity == ang'DOT;
  if ang'ABOVE(ang_max) use
    trq == k_stop * (ang - ang_max) + (damp_stop * velocity);
  elsif ang'ABOVE(ang_min) use
    trq == 0.0;
  else
    trq == k_stop * (ang - ang_min) + (damp_stop * velocity);
  end use;
  break on ang'ABOVE(ang_min), ang'ABOVE(ang_max);
end architecture ideal;