----------------------------------------------------------------------
-- 5. Clutch Model :
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
    use IEEE.MECHANICAL_SYSTEMS.all;
----------------------------------------------------------------------
entity CLUTCH is
  port    (
    quantity Q_in_clutch : in REAL ; 
    terminal MRV_IN  : ROTATIONAL_VELOCITY;
    terminal MRV_OUT : ROTATIONAL_VELOCITY
  );           
end entity CLUTCH;
----------------------------------------------------------------------
architecture SYSTEM of  CLUTCH is
    
  quantity ANGULAR_VELOCITY_IN  across TORQUE_IN  through MRV_IN;
  quantity ANGULAR_VELOCITY_OUT across                    MRV_OUT;
  quantity       TORQUE_OUT through ROTATIONAL_VELOCITY_REF to MRV_OUT;
    
begin
    
  if Q_in_clutch = 0.0 use 
    TORQUE_IN  == 0.0;
    TORQUE_OUT == 0.0;
  else
    TORQUE_IN           == TORQUE_OUT;    
    ANGULAR_VELOCITY_IN == ANGULAR_VELOCITY_OUT;
  end use;
    
end architecture SYSTEM;

