----------------------------------------------------------------------
-- 11. Pulley :
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
    use IEEE.MECHANICAL_SYSTEMS.all;
    use IEEE.MATH_REAL.all;
----------------------------------------------------------------------
entity PULLEY_MODEL is
  generic (
    Ratio : REAL := 3.0; -- gear ratios
    Eta   : REAL := 1.0  -- efficiency
  );
  port (
    terminal MRV_IN  : ROTATIONAL_VELOCITY;  -- provides torque
    terminal MRV_OUT : ROTATIONAL_VELOCITY   -- output torque
  );
end entity  PULLEY_MODEL;
----------------------------------------------------------------------
architecture A0 of PULLEY_MODEL is

  constant RATIO_INTERN : REAL := Ratio ;
  quantity ANGULAR_VELOCITY_IN  across TORQUE_IN  through MRV_IN;
  quantity ANGULAR_VELOCITY_OUT across                    MRV_OUT;
  quantity                             TORQUE_OUT through ROTATIONAL_VELOCITY_REF to MRV_OUT;
    
begin

  ANGULAR_VELOCITY_IN == Ratio * ANGULAR_VELOCITY_OUT;
  TORQUE_OUT == Eta * Ratio * TORQUE_IN;

end architecture A0;
