----------------------------------------------------------------------
-- 7. Differentail gear Model : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
use IEEE.MECHANICAL_SYSTEMS.all;
----------------------------------------------------------------------
entity DF_MODEL is
  generic (
    Ratio : REAL := 4.058;    -- gear ratios
    Eta:REAL:=0.98 -- efficiency
  );
  port (
    terminal MRV_IN  : ROTATIONAL_VELOCITY;  -- provides torque
    terminal MRV_OUT : ROTATIONAL_VELOCITY   -- output torque
  );
end entity  DF_MODEL;
----------------------------------------------------------------------
architecture A0 of DF_MODEL is

  constant RATIO_INTERN : REAL := Ratio ;
  quantity ANGULAR_VELOCITY_IN  across TORQUE_IN  through MRV_IN;
  quantity ANGULAR_VELOCITY_OUT across                    MRV_OUT;
  quantity                             TORQUE_OUT through ROTATIONAL_VELOCITY_REF to MRV_OUT;
    
begin

  ANGULAR_VELOCITY_IN== RATIO*ANGULAR_VELOCITY_OUT;

  if TORQUE_OUT > -0.01 USE
    TORQUE_OUT == Eta * Ratio * TORQUE_IN ;
  else
    TORQUE_OUT * Eta == TORQUE_IN * Ratio ;
  end use;

end architecture A0;
