----------------------------------------------------------------------
-- 6. Transmission Model :
--  6.1 gearbox model 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE ; 
    use IEEE.MECHANICAL_SYSTEMS.all ;

library FUNDAMENTALS_JSAE ;
----------------------------------------------------------------------
entity	Gearbox_model is
  generic (
    J : MOMENT_INERTIA := 0.1 
  ) ;
  port(
    quantity Q_in_gear : in REAL  ; 
    terminal mrv1, mrv2 : ROTATIONAL_V
  ) ;
end entity Gearbox_model;
----------------------------------------------------------------------
architecture struct of Gearbox_model is

begin

  gear_1 : entity WORK.gearbox(a0)
      port map(q_in_gear=>Q_in_gear, MRV_IN=>MRV1, MRV_OUT=>MRV2) ;

  J_intern : entity FUNDAMENTALS_JSAE.mass_rotv_jsae(behav)
      port map(J=>J, rot1=> MRV2) ;

end architecture struct;
----------------------------------------------------------------------
