----------------------------------------------------------------------
--  12.1 ACG Current limit map
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE; 
use IEEE.MATH_REAL.all ; 
library FUNDAMENTALS_VDA;
use FUNDAMENTALS_VDA.TLU_VDA.all;
----------------------------------------------------------------------
entity ALTA_CURRENT_LIMIT_80A_140617  is
  port (
    quantity omg  : in  REAL;  -- quantity input omega [rad/s]
    quantity Ilim : out REAL   -- quantity output
  );
end entity ALTA_CURRENT_LIMIT_80A_140617;
----------------------------------------------------------------------
architecture ARCH of ALTA_CURRENT_LIMIT_80A_140617 is
  constant IN_VALUES : REAL_VECTOR :=
    (1200.0, 1300.0, 1500.0, 1800.0, 2000.0, 2500.0, 3000.0,
     3500.0, 4000.0, 4500.0, 5000.0, 6000.0, 7000.0, 8000.0 ) ; 
  constant OUT_VALUES: REAL_VECTOR :=
    (19.04,  27.16,  41.30,  53.90,  59.15,  67.76,  73.15,
     76.58,  79.45,  80.85,  81.55,  82.53,  83.51,  83.86) ;
  
  quantity q_rpm : REAL ; 
  quantity qlim  : REAL ;     
begin
  
  q_rpm == omg * 60.0/(math_PI*2.0) ;

  qlim == LOOKUP_1D(q_rpm, IN_VALUES, OUT_VALUES); -- evaluation of table
  Ilim == realmax(qlim, 0.0) ;
  
end architecture ARCH ;
