----------------------------------------------------------------------
-- 15. Starter : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
LIBRARY IEEE;
    use IEEE.ELECTRICAL_SYSTEMS.all;
library FUNDAMENTALS_VDA ; 
----------------------------------------------------------------------
entity Starter is
  port (
    terminal EL_in : ELECTRICAL;
    quantity Q_in_ctrl : in REAL := 0.0 -- Control flag (== FuelCut flag) 
  );
end entity Starter;
----------------------------------------------------------------------
architecture struct of Starter is
  
  terminal n0019 : ELECTRICAL;
  terminal n0250 : ELECTRICAL;

  quantity ctrl_del : REAL ; 
  quantity ctrl_starter : REAL ;
  
begin
  
  -- create delayed signal ;
  ----
  ctrl_del == Q_in_ctrl'delayed(0.5) ; 

  -- delayed ON and (not control ON) )
  ----
  if(ctrl_del >= 0.5 and Q_in_ctrl <= 0.5) use 
      ctrl_starter == 1.0 ; 
  else 
      ctrl_starter == 0.0 ;
  end use ;

  starter_r : entity FUNDAMENTALS_VDA.r_vda(basic)
      generic map ( r => 0.02 )
      port map ( el2 => ELECTRICAL_REF, el1 => N0250);

  v_switch_vda1 : entity FUNDAMENTALS_VDA.v_switch_vda(basic)
      port map ( ns => ELECTRICAL_REF, ps =>N0019 , n => N0250, p =>EL_in );

  q2voltage_vda1 : entity FUNDAMENTALS_VDA.q2voltage_vda(simple)
      port map ( el_2 => ELECTRICAL_REF, el_1 => N0019, q_in => ctrl_starter );
  
end architecture struct;
