----------------------------------------------------------------------
-- 16. Fuel consumption calculation :
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
entity	FC_CALC is
  port(
    quantity Q_in_fuel : in REAL := 0.0 ; -- engine fuel [L/h]
    quantity Q_in_veh_v : in REAL := 0.0 ; --vehicle speed [m/s]
    quantity Q_out_fc_out : out REAL   -- total fuel consumption [km/L]
  ) ; 
end entity FC_CALC;
----------------------------------------------------------------------
architecture arch_fc_calc of FC_CALC is

  quantity distance_km : REAL ; -- total distance [km]
  quantity fuel_Lt : REAL ;     -- total fuel consumption [Lt]

begin

  distance_km == Q_in_veh_v'integ / 1000.0 ; 

  fuel_Lt == Q_in_fuel'integ / 3600.0 ; 

  if(abs(fuel_Lt)>= 0.01) use 
      Q_out_fc_out == distance_km / fuel_Lt ;
  else 
      Q_out_fc_out == distance_km / 0.01 ; -- avoid div by zero.
  end use ;

end architecture arch_fc_calc;
----------------------------------------------------------------------
