----------------------------------------------------------------------
-- 1. Controller : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library IEEE;
    use IEEE.all;
library FUNDAMENTALS_VDA ;
library FUNDAMENTALS_JSAE ;
----------------------------------------------------------------------
entity Controller is
  generic (
    target_idle_speed : real := 750.0 ; -- [rpm]
    kaisei_on         : real := 0.0 ;   -- 0 : re_generation off/ 1:re generation on (not used) 
    IdleStop_on       : real := 1.0    -- 0 : Idle stop off / 1 :Idle stop on 
  ) ;
  port (
    quantity Q_out_Kaisei_flag : out REAL;  --[0/1]
    quantity Q_out_Idle_rpm : out REAL;  --[rpm]
    quantity Q_out_ISS_Flag : out REAL;  --0/1
    quantity Q_out_clutch : out REAL;    --0/1
    quantity Q_out_tgt_V : out REAL;     --[km/h]
    quantity Q_out_shift : out REAL     --0 to 5
  );
end entity Controller;
----------------------------------------------------------------------
architecture struct of Controller is
  quantity Qtime : REAL := 0.0;    
begin

  Qtime == now ; 

  clutchdata1 : entity FUNDAMENTALS_VDA.tlu_1d_file_vda(basic)
    generic map (tlufile => "PC_clutch.tab") 
    port map ( q_in => Qtime, q_out => Q_out_clutch );

  shiftdata1 : entity FUNDAMENTALS_VDA.tlu_1d_file_vda(basic)
    generic map (tlufile => "PC_shift.tab") 
    port map ( q_in => Qtime, q_out => Q_out_shift );

  tgt_vehicle1 : entity FUNDAMENTALS_VDA.tlu_1d_file_vda(basic)
    generic map (tlufile => "PC_tgt_vehicleSpeed.tab")          
    port map ( q_in => Qtime, q_out => Q_out_tgt_V );  

  Q_out_Idle_rpm    == target_idle_speed ;
  Q_out_ISS_Flag    == IdleStop_on ;
  Q_out_Kaisei_flag == kaisei_on ;

end architecture struct;

