----------------------------------------------------------------------
-- TORQSENSOR model : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library ieee;
library fundamentals_vda;
library fundamentals_jsae;
----------------------------------------------------------------------
entity EPS1_TORQSENSOR is
  generic(
    SPRING_CONSTANT : REAL:=200.0
  );
  port(
    quantity TQ_SENS : OUT REAL;
    terminal TS_LO : ROTATIONAL;
    terminal TS_UP : ROTATIONAL
  );
end entity EPS1_TORQSENSOR;
----------------------------------------------------------------------
architecture arch_EPS1_TORQSENSOR of EPS1_TORQSENSOR is
  terminal TS_MID: ROTATIONAL;

begin
  SPRING_R1 : entity FUNDAMENTALS_JSAE.SPRING_R_JSAE(LINEAR)
    generic map ( 
      K => SPRING_CONSTANT 
    )
    port map (
      ANG1 => TS_MID,
      ANG2 => TS_LO
    );

  Q_FROM_TORQUE_R1 : entity FUNDAMENTALS_VDA.TORQUE_MR2Q_SENSOR_VDA(SIMPLE)
    port map (
      Q_OUT => TQ_SENS,
      MR_1 => TS_UP,
      MR_2 => TS_MID
    );
end architecture arch_EPS1_TORQSENSOR;