----------------------------------------------------------------------
-- LeadLag Filter : 
--
-- Copyright (C) 2017 JSAE
----------------------------------------------------------------------
library ieee;
  use ieee.math_real.all;
----------------------------------------------------------------------
entity q_LeadLag_jsae is
  generic (
    K : real := 1.0; -- Gain [No Units]
    Fp : real := 20.0e3; -- Pole frequency [Hz]
    Fz : real := 1.0e6; -- Zero frequency [Hz]
    Fsmp : real := 10.0e3 -- For Z-dmn only: Sample frequency [Hz]
  );
  port (
    quantity input : in real;
    quantity output : out real
  );
end entity q_LeadLag_jsae;
----------------------------------------------------------------------
architecture s_dmn of q_LeadLag_jsae is
  constant wp : real := math_2_pi*Fp; -- Pole freq (in radians)
  constant wz : real := math_2_pi*Fz; -- Zero freq (in radians)
  constant num : real_vector := (1.0, 1.0/wz);
  constant den : real_vector := (1.0, 1.0/wp);

begin
  output == K * input'ltf(num, den); -- Laplace transform of input
end architecture s_dmn;