-------------------------------------------------------------------------------
-- CC/CV battery charge controller 
--
-- Copyright (C) 2017 JSAE
-------------------------------------------------------------------------------
library IEEE ; 
    use IEEE.ELECTRICAL_SYSTEMS.all ; 

entity Macro10_rnl is 

  generic (
    vreg : REAL := 14.0 ; 
    clim : REAL := 100.0 
  ) ;
  port(
    quantity vsense : in REAL ;  
    terminal EL1, EL2 : ELECTRICAL 
  ) ; 

end entity Macro10_rnl  ;

architecture beh of Macro10_rnl is 
  quantity v across i through EL1 to EL2 ;
begin
  ---
  -- Note : Use Battery voltate for Vsense.
  --      : Don't use V across quantity because of IR drop.

  break on i'above(clim) ; 
  break on vsense'above(vreg) ;

  if(Vsense <=vreg) use -- BattV < Vregulation=14[V] ;
    if(i<clim) use --(i<=clim) use   -- 1. no limt for current 
      v==0.0 ; 
    else             -- 2. current limit as 100[A]
      i == clim ;
    end use;
  else                 -- 3. BattV >=Vreg (no limit) ;
    v == 0.0 ;
  end use ; 

end architecture beh ; 
