--------------------------------------------------
-- Integrator : 
--
-- Copyright (C) 2017 JSAE
--------------------------------------------------
entity integrator is
  generic (
    K     : REAL;      -- coefficient value K/s
    out0  : REAL:=0.0  -- initial condition for w
           );
  port (
    quantity S_IN   : in  REAL;
    quantity S_OUT  : out  REAL
        );
end entity integrator;

architecture behav of integrator is

begin

  if domain = quiescent_domain use 
    S_OUT == out0 ;
  else
    K * S_IN == S_OUT'dot ;
  end use;

end architecture behav;