--------------------------------------------------
-- Inertia Load : 
--
-- Copyright (C) 2017 JSAE
--------------------------------------------------
library IEEE;
use IEEE.MECHANICAL_SYSTEMS.all;

entity inertia is
  generic (
    J : MOMENT_INERTIA ; -- value of moment of inertia
    D : REAL          @ -- damping coefficient
           );
  port (
    terminal MRV_p : ROTATIONAL_V
        );
end entity inertia;

---------------------------------------------------------
-- Ideal architecture
-- Tload = J*dw/dt
---------------------------------------------------------

architecture behav of inertia is

  quantity w across torq through MRV_p to rotational_v_ref;

begin

  torq == J * w'dot + D * w ;

end architecture behav;