-------------------------------------------------------------------------------
-- fixed frequency sin source
--
-- Copyright (C) 2017 JSAE
-------------------------------------------------------------------------------
library ieee ; 
use ieee.math_real.all ; 

entity SINE is 
	generic (
		phase  : real := 0.0 -- Initial phase [deg]
	) ; 
	port (
		quantity ampl : in real := 326.0 ; -- Amplitude [-]
		quantity freq : in real := 50.0 ;  -- Frequcney [Hz]
		quantity q_out : out real 		-- output ;
		) ; 
end entity SINE ;

architecture beh of SINE is 
	constant phaser : real := phase * math_2_pi / 360.0 ;
	quantity omg : real := 0.0 ; 
begin
	omg == freq * math_2_pi ; 
	q_out == ampl * sin(omg*now + phaser) ;
end architecture beh ;
