-------------------------------------------------------------------------------
-- integral with reset signal
--
-- Copyright (C) 2017 JSAE
-------------------------------------------------------------------------------
entity INTG_RST is

  port (
    quantity y0 : in REAL := 0.0 ; --initial(reset) value
    quantity input : in REAL ;  -- input signal 
    quantity ctrl : in REAL := 1.0 ; -- reset signal (-1/1) 
    quantity ki : in REAL := 1.0 ; -- gain
    quantity val : out REAL := 0.0 --integrated output 
  ) ; 

end entity INTG_RST ;

architecture BEH of INTG_RST is 
  signal sw : BOOLEAN := false ; 
begin

  sw <= ctrl'above(0.0) ; 

  if(sw and (ctrl > 0.0)) use
    val == y0 ; 
  else
    val'dot == KI*input ; 
  end use ;
  
  break on sw ; 

end architecture BEH ;
