-------------------------------------------------------------------------------
-- weighted_summer by procedural
--
-- Copyright (C) 2017 JSAE
-------------------------------------------------------------------------------
library Disciplines;
  use Disciplines.Electromagnetic_System.all;
-------------------------------------------------------------------------------
entity weighted_summer is
  generic (
    beta, gamma: real_vector
  );
  port (
    terminal inp, inm: electrical_vector;
    terminal o: electrical
  );
end entity weighted_summer;
-------------------------------------------------------------------------------
architecture proc of weighted_summer is
  quantity vp across inp; quantity vm across inm;
  quantity vo across io through o;

begin
  procedural is
    variable bvs, gvs: real := 0.0;
  begin
    for i in betaf range loop
      bvs := bvs + beta(i) * vp(i);
    end loop;
    for i in gammaf range loop
      gvs := gvs + gamma(i) * vm(i);
    end loop;
    vo := bvs - gvs;
  end procedural;
end architecture proc;