-------------------------------------------------------------------------------
-- weighted_summer by function
--
-- Copyright (C) 2017 JSAE
-------------------------------------------------------------------------------
library Disciplines;
  use Disciplines.Electromagnetic_System.all;
-------------------------------------------------------------------------------
entity weighted_summer is
  generic (
    beta, gamma: real_vector
  );
  port (
    terminal inp, inm: electrical_vector;
    terminal o: electrical
  );
end entity weighted_summer;
-------------------------------------------------------------------------------
architecture func of weighted_summer is
  quantity vp across inp;
  quantity vm across inm;
  quantity vo across io through o;
-------------------------------------------------------------------------------
  function proc_eq return real is
    variable bvs, gvs : real := 0.0;
    variable vo : real;
  begin
    for i in betaf range loop
      bvs := bvs + beta(i) * vp(i);
    end loop;
    for i in gammaf range loop
      gvs := gvs + gamma(i) * vm(i);
    end loop;
    vo := bvs - gvs;
    return vo;
  end function proc_eq;

  begin
    vo == proc_eq;
end architecture func;